//
//  CloseButton.m
//  AnimationExplorer
//
//  Copyright (c) 2012 Nathan Corvino.
//  Some rights reserved: http://opensource.org/licenses/MIT
//

#import "CloseButton.h"

@implementation CloseButton

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor clearColor];
    }
    return self;
}

- (void)drawRect:(CGRect)rect
{
    CGRect bounds = self.bounds;
    CGContextRef context = UIGraphicsGetCurrentContext();

    CGContextSetFillColorWithColor(context, [UIColor whiteColor].CGColor);
    CGContextFillEllipseInRect(context, bounds);

    CGContextSetLineWidth(context, 2.);
    CGContextSetStrokeColorWithColor(context, [UIColor blackColor].CGColor);
    CGContextStrokeEllipseInRect(context, CGRectInset(bounds, 1., 1.));

    CGContextSetFillColorWithColor(context, [UIColor blackColor].CGColor);
    NSString *text = @"X";
    UIFont *textFont = [UIFont systemFontOfSize:20.];
    CGSize textSize = [text sizeWithFont:textFont];

    [@"X" drawInRect:CGRectMake(floorf((bounds.size.width - textSize.width) / 2.), floorf((bounds.size.height - textSize.height) / 2.), bounds.size.width, bounds.size.height)
            withFont:textFont];
}


@end
