//
//  ParentView.m
//  AnimationExplorer
//
//  Copyright (c) 2012 Nathan Corvino.
//  Some rights reserved: http://opensource.org/licenses/MIT
//

#import "ParentView.h"

@interface ParentView ()

- (void)setupFrameShape;

@end

@implementation ParentView

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super initWithCoder:aDecoder];
    if (self) {
        gridLayers = [NSMutableArray array];
        [self setupFrameShape];
    }
    return self;
}

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self setupFrameShape];
    }
    return self;
}

- (void)setupFrameShape
{
    _frameShape = [CAShapeLayer layer];
    _frameShape.fillColor = nil;
    _frameShape.strokeColor = [UIColor blueColor].CGColor;
    _frameShape.lineWidth = 3.;
    _frameShape.frame = self.bounds;
    [self.layer addSublayer:_frameShape];

    [self addObserver:self forKeyPath:@"targetView.frame" options:NSKeyValueObservingOptionNew context:nil];
    [self addObserver:self forKeyPath:@"targetView.bounds" options:NSKeyValueObservingOptionNew context:nil];
    [self addObserver:self forKeyPath:@"targetView.center" options:NSKeyValueObservingOptionNew context:nil];
    [self addObserver:self forKeyPath:@"targetView.transform" options:NSKeyValueObservingOptionNew context:nil];
    [self addObserver:self forKeyPath:@"targetView.layer.transform" options:NSKeyValueObservingOptionNew context:nil];
}

- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
    _frameShape.path = CGPathCreateWithRect(_targetView.frame, NULL);
}

@end
