//
//  ViewController.h
//  AnimationExplorer
//
//  Copyright (c) 2012 Nathan Corvino.
//  Some rights reserved: http://opensource.org/licenses/MIT
//

#import <UIKit/UIKit.h>
#import "ParentView.h"

@interface ViewController : UIViewController {
    UIView *currentPane;

    UIView *popupBackground;
    UIView *popupContent;

    UIView *currentPopupPane;
}

@property (weak, nonatomic) IBOutlet ParentView *parentView;
@property (weak, nonatomic) IBOutlet UIView *targetView;

@property (weak, nonatomic) IBOutlet UIView *editPane;
@property (weak, nonatomic) IBOutlet UISegmentedControl *propertySegments;

@property (weak, nonatomic) IBOutlet UILabel *dataTypeLabel;

@property (strong, nonatomic) IBOutlet UIView *rectPane;
@property (strong, nonatomic) IBOutlet UIView *pointPane;
@property (strong, nonatomic) IBOutlet UIView *transformPane;
@property (strong, nonatomic) IBOutlet UIView *transform3DPane;

@property (weak, nonatomic) IBOutlet UITextField *rectOriginX;
@property (weak, nonatomic) IBOutlet UITextField *rectOriginY;
@property (weak, nonatomic) IBOutlet UITextField *rectWidth;
@property (weak, nonatomic) IBOutlet UITextField *rectHeight;

@property (weak, nonatomic) IBOutlet UITextField *pointX;
@property (weak, nonatomic) IBOutlet UITextField *pointY;

@property (weak, nonatomic) IBOutlet UITextField *transformA;
@property (weak, nonatomic) IBOutlet UITextField *transformB;
@property (weak, nonatomic) IBOutlet UITextField *transformC;
@property (weak, nonatomic) IBOutlet UITextField *transformD;
@property (weak, nonatomic) IBOutlet UITextField *transformTx;
@property (weak, nonatomic) IBOutlet UITextField *transformTy;

@property (weak, nonatomic) IBOutlet UITextField *transformM11;
@property (weak, nonatomic) IBOutlet UITextField *transformM12;
@property (weak, nonatomic) IBOutlet UITextField *transformM13;
@property (weak, nonatomic) IBOutlet UITextField *transformM14;
@property (weak, nonatomic) IBOutlet UITextField *transformM21;
@property (weak, nonatomic) IBOutlet UITextField *transformM22;
@property (weak, nonatomic) IBOutlet UITextField *transformM23;
@property (weak, nonatomic) IBOutlet UITextField *transformM24;
@property (weak, nonatomic) IBOutlet UITextField *transformM31;
@property (weak, nonatomic) IBOutlet UITextField *transformM32;
@property (weak, nonatomic) IBOutlet UITextField *transformM33;
@property (weak, nonatomic) IBOutlet UITextField *transformM34;
@property (weak, nonatomic) IBOutlet UITextField *transformM41;
@property (weak, nonatomic) IBOutlet UITextField *transformM42;
@property (weak, nonatomic) IBOutlet UITextField *transformM43;
@property (weak, nonatomic) IBOutlet UITextField *transformM44;


// Affine Transform Outlets

@property (strong, nonatomic) IBOutlet UISegmentedControl *transformSegments;
@property (strong, nonatomic) IBOutlet UIView *affineTransformPopup;
@property (strong, nonatomic) IBOutlet UIView *affineTransformEditPane;

@property (strong, nonatomic) IBOutlet UIView *rotatePane;
@property (strong, nonatomic) IBOutlet UIView *scalePane;
@property (strong, nonatomic) IBOutlet UIView *translatePane;
@property (strong, nonatomic) IBOutlet UIView *concatPane;

@property (strong, nonatomic) IBOutlet UISwitch *makeNewRotation;
@property (strong, nonatomic) IBOutlet UITextField *transformRotateValue;

@property (strong, nonatomic) IBOutlet UISwitch *makeNewScale;
@property (strong, nonatomic) IBOutlet UITextField *transformSx;
@property (strong, nonatomic) IBOutlet UITextField *transformSy;

@property (strong, nonatomic) IBOutlet UISwitch *makeNewTranslation;
@property (strong, nonatomic) IBOutlet UITextField *transformPaneTx;
@property (strong, nonatomic) IBOutlet UITextField *transformPaneTy;

@property (strong, nonatomic) IBOutlet UITextField *transformPaneA;
@property (strong, nonatomic) IBOutlet UITextField *transformPaneB;
@property (strong, nonatomic) IBOutlet UITextField *transformPaneC;
@property (strong, nonatomic) IBOutlet UITextField *transformPaneD;
@property (strong, nonatomic) IBOutlet UITextField *transformPaneConcatTx;
@property (strong, nonatomic) IBOutlet UITextField *transformPaneConcatTy;

- (IBAction)doTransform:(id)sender;

- (IBAction)segmentChanged:(UISegmentedControl *)sender;
- (IBAction)changeProperty:(id)sender;

@end
